import { Text, DataQueryMethod, DataQueryFunction } from '../config';
import { ColumnType } from '../data';
import { DatasetColumnType_Server } from './dataset';
export declare enum ConfigDataBlockType_Server {
    Column = 'column',
    Filter = 'filter',
    Sort = 'sort',
    Colorizer = 'colorizer',
    Drilldown = 'drilldown',
}
export interface Config_Server {
    label: Text;
    icon: string;
    data_options: ConfigDataOption_Server[];
    doc: {
        info: string;
        assets: string;
        images: string[];
    };
    sdk_version: string;
    type?: string;
    version: string;
}
export interface ConfigDataOption_Server {
    key: string;
    method: DataQueryMethod;
    label?: Text;
    min?: number;
    max?: number;
    validation?: {
        required_some?: string[];
        required_every?: string[];
    };
    blocks: ConfigDataOptionBlock_Server[];
}
export interface ConfigDataOptionBlock_Server {
    type: ConfigDataBlockType_Server;
    key: string;
    label: Text;
    icon?: string;
    data_type?: DatasetColumnType_Server;
    field_type?: ColumnType;
    max?: number;
    function?: DataQueryFunction;
}
export declare const configDataBlock_Server =
    '8316067a-d04b-4b21-bd4d-35529846617b';
export declare const blockFilterKey = '34642664-dbd1-4e35-b0ea-2eaabe796b48';
export declare const blockSortKey = '2c849ed6-6105-4aa2-a961-9f95135dfe3b';
export declare const blockColorizeKey = 'badd51f7-82ce-45b2-a67e-37d52df88c5c';
export declare function decodeDrilldownData(
    source: string,
    additionalFilterSources: string[],
): string;
export declare function encodeDrilldownData(key: string): {
    source: string;
    additionalFilterSources: string[];
};
