"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.encodeDrilldownData = exports.decodeDrilldownData = exports.blockColorizeKey = exports.blockSortKey = exports.blockFilterKey = exports.configDataBlock_Server = exports.ConfigDataBlockType_Server = void 0;
// enums
var ConfigDataBlockType_Server;
(function (ConfigDataBlockType_Server) {
    ConfigDataBlockType_Server["Column"] = "column";
    ConfigDataBlockType_Server["Filter"] = "filter";
    ConfigDataBlockType_Server["Sort"] = "sort";
    ConfigDataBlockType_Server["Colorizer"] = "colorizer";
    ConfigDataBlockType_Server["Drilldown"] = "drilldown";
})(ConfigDataBlockType_Server = exports.ConfigDataBlockType_Server || (exports.ConfigDataBlockType_Server = {}));
exports.configDataBlock_Server = '8316067a-d04b-4b21-bd4d-35529846617b';
exports.blockFilterKey = '34642664-dbd1-4e35-b0ea-2eaabe796b48';
exports.blockSortKey = '2c849ed6-6105-4aa2-a961-9f95135dfe3b';
exports.blockColorizeKey = 'badd51f7-82ce-45b2-a67e-37d52df88c5c';
function decodeDrilldownData(source, additionalFilterSources) {
    const keyParts = [length(source.length), source];
    additionalFilterSources.forEach((item) => keyParts.push(length(item.length), item));
    return keyParts.join('');
    function length(value) {
        if (value > 0xff)
            throw new RangeError();
        return value > 0xf
            ? `0x${value.toString(16)}`
            : `0x0${value.toString(16)}`;
    }
}
exports.decodeDrilldownData = decodeDrilldownData;
function encodeDrilldownData(key) {
    const parts = [];
    parse();
    const [source, ...additionalFilterSources] = parts;
    return {
        source,
        additionalFilterSources,
    };
    function parse(offset = 0) {
        const start = offset + 4;
        const end = start + parseInt(key.slice(offset, start));
        parts.push(key.slice(start, end));
        if (end < key.length)
            parse(end);
    }
}
exports.encodeDrilldownData = encodeDrilldownData;
