"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.valueConversion = exports.viewSettingsExtract = exports.viewSettingsItemValue = exports.ViewSettingsItemType = void 0;
var ViewSettingsItemType;
(function (ViewSettingsItemType) {
    ViewSettingsItemType["Input"] = "text";
    ViewSettingsItemType["Checkbox"] = "checkbox";
    ViewSettingsItemType["Radio"] = "radio";
    ViewSettingsItemType["Select"] = "select";
    ViewSettingsItemType["ColorPicker"] = "color-picker";
    ViewSettingsItemType["Title"] = "title";
    ViewSettingsItemType["TextArea"] = "textArea";
})(ViewSettingsItemType = exports.ViewSettingsItemType || (exports.ViewSettingsItemType = {}));
exports.viewSettingsItemValue = '418d9556-a046-4623-be0b-4f4f69ccb783';
function viewSettingsExtract(viewSettings) {
    return viewSettings
        .map((item) => item[exports.viewSettingsItemValue])
        .map((item) => ({
        type: item.type,
        key: item.key,
        label: item.label,
        defaultValue: valueConversion(item.type, item.defaultValue),
        options: item.options || [],
        span: getSpan(item.span),
    }));
}
exports.viewSettingsExtract = viewSettingsExtract;
function valueConversion(type, source) {
    switch (type) {
        case ViewSettingsItemType.Input:
        case ViewSettingsItemType.Radio:
        case ViewSettingsItemType.Select:
        case ViewSettingsItemType.ColorPicker:
        case ViewSettingsItemType.TextArea:
            return source ? String(source) : '';
        case ViewSettingsItemType.Checkbox:
            return Boolean(source);
        default:
            return '';
    }
}
exports.valueConversion = valueConversion;
function getSpan(source) {
    source |= 0;
    if (source > 24)
        return 24;
    if (source < 0)
        return 0;
    return source;
}
