import { DataQueryMethod, DataQueryFunction } from '../config';
import { Dataset_Server } from './dataset';
import { ConfigDataBlockType_Server } from './config';
import { ColorizeItem, Widget } from '../widget';
import { Column, DataItem } from '../data';
export declare const widgetDefaultKey = "ffed0a4d-4a9d-417f-b502-eb50142c6956";
export interface Widget_Server {
    data_options: WidgetDataOption_Server[];
    view_options: WidgetViewOption_Server[];
}
export interface WidgetRepresent {
    dataOptionsMap: DatasetMultiData_Server;
    viewOptions: WidgetViewOption_Server[];
}
export interface DatasetMultiData_Server {
    [key: string]: {
        data_option: WidgetDataOption_Server;
        rows: DataItem[];
        total: number;
    };
}
export interface WidgetDataOption_Server {
    key: string;
    id: number;
    dataset: Dataset_Server;
    method: DataQueryMethod;
    limit_rows: number;
    offset: number;
    blocks: WidgetDataOptionBlock_Server[];
}
export interface WidgetDataOptionParams_Server {
    id?: number;
    dataset_id: number;
    method: DataQueryMethod;
    limit_rows?: number;
    offset?: number;
    key?: string;
    blocks: WidgetDataOptionBlock_Server[];
}
export interface WidgetDataOptionColumn_Server {
    column_id: number;
    value?: any;
    action?: string;
}
export interface WidgetDataOptionBlock_Server {
    key: string;
    block_type: ConfigDataBlockType_Server;
    function: DataQueryFunction;
    columns: WidgetDataOptionColumn_Server[];
}
export interface WidgetViewOption_Server {
    key: string;
    value: any;
}
export interface ColorizeSettings_Server {
    columnId: number;
    max?: number;
    min?: number;
    threshold?: number;
    colorAbove?: number;
    colorBelow?: number;
}
export declare function createColorizeItem(widget: Widget, column: Column, source: ColorizeSettings_Server): ColorizeItem;
export declare function dispatchChangeOtherFilters(widget: any, source: WidgetDataOptionColumn_Server[]): void;
